﻿local addonName = "Altoholic"
local addon = _G[addonName]

local BF = LibStub("LibBabble-Faction-3.0"):GetLookupTable()

if GetLocale() ~= "zhTW" then return end

local WHITE		= "|cFFFFFFFF"
local GREEN		= "|cFF00FF00"
local YELLOW	= "|cFFFFFF00"

-- 以下為聲望值、等級、技能等的建議
addon.FactionLeveling = {

	-- 聲望值級別
	-- -42000 = "仇恨"
	-- -6000 = "敵對"
	-- -3000 = "冷淡"
	-- 0 = "中立"
	-- 3000 = "友善"
	-- 9000 = "尊敬"
	-- 21000 = "崇敬"
	-- 42000 = "崇拜"
	
	-- Outland factions: source: http://www.mmo-champion.com/
	[BF["The Aldor"]] = {
		[0] = WHITE .. "[懼牙毒囊]|r +250 聲望值\n\n"
				.. YELLOW .. "懼牙潛伏者,\n懼牙寡婦蛛\n"
				.. WHITE .. "(泰洛卡森林)",
		[9000] = WHITE .. "[基爾加丹印記]|r\n+25 聲望值",
		[42000] = WHITE .. "[薩格拉斯印記]|r +25 聲望值/每枚\n" 
				.. GREEN .. "[魔化武器]|r +350 聲望值 (+1 神聖之塵)"
	},
	[BF["The Scryers"]] = {
		[0] = WHITE .. "[濕鱗蜥蜴的眼睛]|r +250 聲望值\n\n"
				.. YELLOW .. "鐵脊石化者,\n濕鱗吞噬者,\n濕鱗蜥蜴\n"
				.. WHITE .. "(泰洛卡森林)",
		[9000] = WHITE .. "[火翼徽記]|r\n+25 聲望值",
		[42000] = WHITE .. "[日怒徽記]|r +25 聲望值 per mark\n" 
				.. GREEN .. "[秘法寶典]|r +350 聲望值 (+1 秘法符文)"
	},
	[BF["Netherwing"]] = {
		[3000] = "重複以下任務:\n\n" 
				.. YELLOW .. "慢速死亡 (每日)|r +250 聲望值\n"
				.. YELLOW.. "虛空之塵花粉 (每日)|r +250 聲望值\n"
				.. YELLOW.. "虛空之翼水晶 (每日)|r +250 聲望值\n"
				.. YELLOW.. "不太友善的航線 (每日)|r +250 聲望值\n"
				.. YELLOW.. "尋找虛空之翼龍卵 (可重複提交)|r +250 聲望值",
		[9000] = "重複以下任務:\n\n" 
				.. YELLOW .. "新的監工:正確的選擇|r +350 聲望值\n"
				.. YELLOW .. "迴力靴:專治沒用的苦工 (每日)|r +350 聲望值\n"
				.. YELLOW .. "拾起貨品 (每日)|r +350 聲望值\n"
				.. YELLOW .. "龍的問題不算什麼 (每日)|r +350 聲望值\n"
				.. YELLOW .. "瘋狂與困惑|r +350 聲望值\n",
		[21000] = "重複以下任務:\n\n" 
				.. YELLOW .. "征服者雷薩赫爾頓|r +500 聲望值\n" 
				.. YELLOW .. "瓦解暮光傳送門 (每日)|r +500 聲望值\n"
				.. YELLOW .. "你的雙翼 +500 聲望值(1-5號), +1000 聲望值(6號)\n",
		[42000] = "重複以下任務:\n\n" 
				.. YELLOW .. "史上最致命的陷阱 (每日) (3+)|r +500 聲望值"
	},
	[BF["Honor Hold"]] = {
		[9000] = "\n" 
				.. YELLOW .. "地獄火半島的任務\n"
				.. GREEN .. "地獄火壁壘 |r(普通)\n"
				.. GREEN .. "血熔爐 |r(普通)",
		[42000] = "\n" 
				.. GREEN .. "破碎大廳 |r(普通或英雄)\n"
				.. GREEN .. "地獄火壁壘 |r(英雄)\n"
				.. GREEN .. "血熔爐 |r(英雄)"
	},
	[BF["Thrallmar"]] = {
		[9000] = "\n" 
				.. YELLOW .. "地獄火半島的任務\n"
				.. GREEN .. "地獄火壁壘 |r(普通)\n"
				.. GREEN .. "血熔爐 |r(普通)",		
		[42000] = "\n" 
				.. GREEN .. "破碎大廳 |r(普通或英雄)\n"
				.. GREEN .. "地獄火壁壘 |r(英雄)\n"
				.. GREEN .. "血熔爐 |r(英雄)"
	},
	[BF["Cenarion Expedition"]] = {
		[3000] = "\n" 
				.. WHITE .. "暗潮納迦或者血鱗納迦 (+5 聲望值)\n"
				.. YELLOW .. "贊格沼澤的任務\n"
				.. "|r殺入任意 " .. GREEN .. "盤牙洞穴|r 的副本\n\n"
				.. WHITE .. "保存 [未鑒定過的植物] 為稍後上繳",	
		[9000] = "\n" 
				.. WHITE .. "上繳 [未鑒定過的植物] x240\n"
				.. YELLOW .. "贊格沼澤的任務\n"
				.. "|r殺入任意 " .. GREEN .. "盤牙洞穴|r 的副本",
		[42000] = "\n" 
				.. WHITE .. "上繳 [盤牙裝備] +75 聲望值\n\n"
				.. GREEN .. "蒸汽洞窟 |r(普通)\n"
				.. GREEN .. "任何盤牙洞穴的副本 |r(英雄)"
	},
	[BF["Keepers of Time"]] = {
		[42000] = "\n" 
				.. "|r殺入 " .. GREEN .. "舊希爾斯布萊德丘陵|r 和 " .. GREEN .. "黑色沼澤|r 副本\n\n"
				.. YELLOW .. "最後交任務:\n'舊希爾斯布萊德丘陵'任務線共計 5000 聲望值\n'黑色沼澤'任務線共計 8000 聲望值"
	},
	[BF["The Sha'tar"]] = {
		[42000] = "\n" 
				.. GREEN .. "波塔尼卡 |r(普通或英雄)\n"
				.. GREEN .. "麥克那爾 |r(普通或英雄)\n"
				.. GREEN .. "亞克崔茲 |r(普通或英雄)\n"
	},	
	[BF["Lower City"]] = {
		[9000] = "\n" 
				.. WHITE .. "上繳 [阿拉卡羽毛]x30 (+250 聲望值)\n"
				.. GREEN .. "暗影迷宮 |r(普通)\n"
				.. GREEN .. "奧奇奈地穴 |r(普通)\n"
				.. GREEN .. "塞司克大廳 |r(普通)",
		[42000] = "\n" 
				.. GREEN .. "暗影迷宮 |r(普通或英雄)\n"
				.. GREEN .. "奧奇奈地穴 |r(英雄)\n"
				.. GREEN .. "塞司克大廳 |r(英雄)"
	},	
	[BF["The Consortium"]] = {
		[3000] = "\n" 
				.. "|r上繳 [沃舒古水晶碎片] +250 聲望值\n"
				.. "上繳 [象牙] +250 聲望值\n\n"
				.. GREEN .. "法力墓地 |r(普通)",
		[9000] = "\n" 
				.. "|r上繳 [黑曜石戰爭珠串] +250 聲望值\n\n"
				.. GREEN .. "法力墓地 |r(普通)",
		[42000] = "\n" 
				.. "|r上繳 [薩克希斯徽記] +250 聲望值\n"
				.. "|r上繳 [黑曜石戰爭珠串] +250 聲望值\n\n"
				.. GREEN .. "法力墓地 |r(英雄)"
	},
	[BF["Shattered Sun Offensive"]] = {
		[42000] = "\n" 
					.. YELLOW .. "完成奎爾達納斯島和薩塔斯城的相關每日任務"
	},
	[BF["The Mag'har"]] = {
		[42000] = "\n" 
				.. "|r上繳 [黑曜石戰爭珠串] +250 聲望值\n\n"
				.. WHITE .. "納葛蘭和泰洛卡森林的任何巨魔 (+5-11 聲望值)\n"
				.. YELLOW .. "完成納葛蘭的任務"
	},
	[BF["Kurenai"]] = {
		[42000] = "\n" 
				.. "|r上繳 [黑曜石戰爭珠串] +250 聲望值\n\n"
				.. WHITE .. "納葛蘭和泰洛卡森林的任何巨魔 (+5-11 聲望值)\n"
				.. YELLOW .. "完成納葛蘭的任務"
	},
	[BF["Sporeggar"]] = {
		[0] = "\n" 
				.. "上繳 [成熟的孢子] 或者 [沼澤領主觸鬚] +250 聲望值\n\n"
				.. YELLOW .. "沼澤領主,\n打開[孢子囊]\n"
				.. WHITE .. "(贊格沼澤)",
		[3000] = "\n" 
				.. "上繳 [白閃菇] +250 聲望值\n\n"
				.. "上繳 [成熟的孢子] 或者 [沼澤領主觸鬚] +250 聲望值\n\n"
				.. YELLOW .. "沼澤領主,\n打開[孢子囊]\n"
				.. WHITE .. "(贊格沼澤)",
		[42000] = "\n" 
				.. WHITE .. "上繳 [紅色木槿] +250 聲望值\n\n"
				.. GREEN .. "深幽泥澤 |r(普通或者英雄)\n"
				.. "上繳 [成熟的孢子] +250 聲望值\n\n"
				.. YELLOW .. "現在 我們是朋友了… (可重複)|r +250 聲望值\n"
	},
	[BF["Sha'tari Skyguard"]] = {
		[42000] = "\n" 
				.. YELLOW.. "轟炸司凱堤斯 (每日)|r +350 聲望值\n"
				.. YELLOW.. "逃離司凱堤斯 (每日)|r +350 聲望值\n"
				.. YELLOW.. "敵人的血 (可重複)|r +350 聲望值\n"
				.. YELLOW.. "召喚泰洛卡 (可重複)|r +350 聲望值\n"
				.. WHITE .. "(司凱堤斯)"
				.. YELLOW.. "再度轟炸 (每日)|r +500 聲望值\n"
				.. YELLOW.. "捆綁更多蒼穹鰭刺 (每日)|r +500 聲望值\n"
				.. YELLOW.. "聖物的增益 (每日)|r +350 聲望值\n"
				.. YELLOW.. "放逐更多惡魔 (每日)|r +350 聲望值\n"
				.. WHITE .. "(劍刃山脈)",
	},
	[BF["Ogri'la"]] = {
		[42000] = "\n" 
				.. YELLOW.. "再度轟炸 (每日)|r +500 聲望值\n"
				.. YELLOW.. "捆綁更多蒼穹鰭刺 (每日)|r +500 聲望值\n"
				.. YELLOW.. "聖物的增益 (每日)|r +350 聲望值\n"
				.. YELLOW.. "放逐更多惡魔 (每日)|r +350 聲望值\n"
				.. WHITE .. "(劍刃山脈)",
	}
}
