﻿--[[
	Project: HideParty
	Version: 2.1
	Website: http://wow.curseforge.com/addons/hideparty/
	Author: Erfolg

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>. 
]] 

local AL3 = LibStub("AceLocale-3.0")

local L = AL3:NewLocale("HideParty", "enUS", true)
if L then
L["addon_desc"] = "HideParty allows you to hide the Raid, Party or Player default unit frames."
L["HideRaid"] = "Hide Raid Frames"
L["HideParty"] = "Hide Party Frames"
L["HidePlayer"] = "Hide Player Frame"
L["HideTarget"] = "Hide Target Frame"
L["HideRaidDesc"] = "Hides the Blizzard raid frame manager"
L["HidePartyDesc"] = "Hides the Blizzard party frames"
L["HidePlayerDesc"] = "Hides the Blizzard player frame"
L["HideTargetDesc"] = "Hides the Blizzard target frame"
L["OnLoad"] = "\124cFF00FF7FHideParty 2.1 by Erfolg loaded. Type /hideparty for options."
L["OnLoad2"] = "\124cFF00FF7FAll comments and suggestions are appreciated."
if GetLocale() == "enUS" or GetLocale() == "enGB" then return end
end

local L = AL3:NewLocale("HideParty", "deDE", true)
if L then
L["addon_desc"] = "HideParty können Sie die Raid verstecken, Party oder Player Standardmaßeinheit Frames."
L["HideRaid"] = "Verstecken Raid-Frames"
L["HideParty"] = "Verstecken Party-Frames"
L["HidePlayer"] = "Verstecken Player-Frame"
L["HideTarget"] = "Verstecken Target Frame"
L["HideRaidDesc"] = "Blendet das Blizzard Raid Frame Manager"
L["HidePartyDesc"] = "Blendet die Blizzard Partei Frames"
L["HidePlayerDesc"] = "Blendet die Blizzard-Spieler Rahmen"
L["HideTargetDesc"] = "Blendet die Blizzard Zielrahmen"
L["OnLoad"] = "\124cFF00FF7FHideParty 2.1 von Erfolg geladen. Bitte typen Sie /hideparty für Optionen."
L["OnLoad2"] = "\124cFF00FF7FAlle Anmerkungen und Anregungen sind erwünscht."
return end

local L = AL3:NewLocale("HideParty", "esES") or AL3:NewLocale("HideParty", "esMX")
if L then
L["addon_desc"] = "HideParty permite ocultar el Raid, el Partido o reproductor de marcos de unidad por defecto."
L["HideRaid"] = "Ocultar Marcos Raid"
L["HideParty"] = "Ocultar Marcos Parte"
L["HidePlayer"] = "Ocultar marco Player"
L["HideTarget"] = "Ocultar marco de Destino"
L["HideRaidDesc"] = "Oculta la incursión de Blizzard gerente de marco"
L["HidePartyDesc"] = "Oculta los marcos de parte de Blizzard"
L["HidePlayerDesc"] = "Oculta el marco jugador de Blizzard"
L["HideTargetDesc"] = "Oculta el marco de destino de Blizzard"
L["OnLoad"] = "\124cFF00FF7FHideParty 2.1 por Erfolg cargado. Tipo /hideparty para conocer las opciones."
L["OnLoad2"] = "\124cFF00FF7FTodos los comentarios y sugerencias son apreciadas."
return end


local L = AL3:NewLocale("HideParty", "frFR")
if L then
L["addon_desc"] = "HideParty permet de cacher le Raid, cadres Partie ou d'un lecteur d'unité par défaut."
L["HideRaid"] = "Masquer les encadrés Raid"
L["HideParty"] = "Masquer les encadrés Party"
L["HidePlayer"] = "Masquer Frame Player"
L["HideTarget"] = "Cadre de destination Masquer"
L["HideRaidDesc"] = "Cuirs le gestionnaire de Blizzard cadre raid"
L["HidePartyDesc"] = "Il cache les cadres partie Blizzard"
L["HidePlayerDesc"] = "Masque le cadre du lecteur Blizzard"
L["HideTargetDesc"] = "Masque le cadre cible Blizzard"
L["OnLoad"] = "\124cFF00FF7FHideParty 2.1 par Erfolg chargé. Type /hideparty pour les options."
L["OnLoad2"] = "\124cFF00FF7FTous les commentaires et suggestions sont les bienvenus."
return end


local L = AL3:NewLocale("HideParty", "koKR")
if L then
L["addon_desc"] = "HideParty는 RAID를, 파티 또는 플레이어의 기본 단위에서 프레임을 숨길 수있는 간단한 addon입니다."
L["HideRaid"] = "레이드 프레임 숨기기"
L["HideParty"] = "파티 프레임 숨기기"
L["HidePlayer"] = "플레이어 프레임 숨기기"
L["HideTarget"] = "숨기기 대상 프레임"
L["HideRaidDesc"] = "블리자드의 기습 프레임 관리자에 숨겨져"
L["HidePartyDesc"] = "블리자드 파티 프레임을 숨깁니다"
L["HidePlayerDesc"] = "블리자드 플레이어 프레임을 숨깁니다"
L["HideTargetDesc"] = "숨깁니다 블리자드 대상 프레임"
L["OnLoad"] = "\124cFF00FF7F로 HideParty은 2.1로드 Erfolg. 유형 옵션 /hideparty."
L["OnLoad2"] = "\124cFF00FF7F모든 의견과 제안을 받게 될것이다."
return
end

local L = AL3:NewLocale("HideParty", "ruRU")
if L then
L["addon_desc"] = "HideParty который позволяет скрывать Raid, участника или игрока кадров по умолчанию устройство."
L["HideRaid"] = "Скрыть Raid кадров"
L["HideParty"] = "Скрыть Стороны кадров"
L["HidePlayer"] = "Скрыть Player Frame"
L["HideTarget"] = "Скрыть Конечная рамка"
L["HideRaidDesc"] = "Скрытие рамки Blizzard RAID Manager"
L["HidePartyDesc"] = "Скрывает кадров Blizzard партии"
L["HidePlayerDesc"] = "Скрытие рамки Blizzard игрок"
L["HideTargetDesc"] = "Скрытие рамки Blizzard целевой"
L["OnLoad"] = "\124cFF00FF7FHideParty 2.1 от Erfolg загружен. Тип /hideparty для вариантов."
L["OnLoad2"] = "\124cFF00FF7FВсе замечания и предложения приветствуются."
return
end
