--[[


Movable Holy Power

by evil.oz
1.43
----
toc bump

1.42
----
main frame is now a child of UIParent
 
1.41
----
more range to x/y offset
moved saving variables to global from percharacter 

1.4
---
added options to see bar in combat, mounted and in vehicle (by popular request)

1.3
---
no bar while in vehicle

1.2
---
removed bar when mounted

1.1
---
fix on scaling sliders

1.0
---
initial un-release


]]

function MovableHolyPower_OnLoad(this)

	MovableHolyPower_combat=nil

	local cls, class = UnitClass("player");
	if (class == "PALADIN") then
		
		local events={}
		
		function events:VARIABLES_LOADED()
			DEFAULT_CHAT_FRAME:AddMessage("Movable Holy Power loaded sucessful", 1.0, 1.0, 0.0);
			PaladinPowerBar:SetAlpha(0)
			
			MovableHolyPower_panel = MovableHolyPower_options
		        MovableHolyPower_panel.name = "Movable Holy Power"
			MovableHolyPower_panel.okay = MovableHolyPower_PanelOk
		        MovableHolyPower_panel.cancel = MovableHolyPower_PanelCancel
			InterfaceOptions_AddCategory(MovableHolyPower_panel)
				
			if (not MovableHolyPower_data) then
				MovableHolyPower_resetData()
			end
	
			MovableHolyPower_createFrames()
		end
		
		function events:PLAYER_REGEN_DISABLED()
			MovableHolyPower_combat="we are under attack"
	    		MovableHolyPower_Refresh()

		end
		
		function events:PLAYER_REGEN_ENABLED()
			MovableHolyPower_combat= nil
	   		MovableHolyPower_Refresh()
		end
		
		function events:COMPANION_UPDATE()
			MovableHolyPower_Refresh()
		end
		
		function events:UNIT_POWER(unit,type)
			if unit == "player" and type == "HOLY_POWER" then
				MovableHolyPower_Refresh()
	    		end
		end
		
		
		function events:UNIT_ENTERED_VEHICLE(unit)
			if unit == "player" then
				MovableHolyPower_Refresh()
	    		end
		end
				
		function events:UNIT_EXITED_VEHICLE(unit)
			if unit == "player" then
				MovableHolyPower_Refresh()
	    		end
		end
		
		-- activate events (cryptic blizz crap)
		MovableHolyPower_frame:SetScript("OnEvent", 	function(self, event, ...)
		 							events[event](self, ...); 
								end
						);
		for k, v in pairs(events) do
			MovableHolyPower_frame:RegisterEvent(k);
		end
		
	else 
		DEFAULT_CHAT_FRAME:AddMessage("Movable Holy Power disabled, not a paladin", 1.0, 1.0, 0.0);
	end

end


-- toggle function
function  MovableHolyPower_Refresh()

	if (not IsMounted() or MovableHolyPower_data.showWhenMounted) and (not UnitInVehicle("player") or MovableHolyPower_data.showInVehicle) and (MovableHolyPower_combat or MovableHolyPower_data.showOffCombat) then
		MovableHolyPower_frame:Show()
	else			
		MovableHolyPower_frame:Hide()
	end
	
	local power = UnitPower("player",9)
	local i
        for i=0,3 do
		if  i==power then
			getglobal("MovableHolyPower_frame_f"..i):Show()
		else
			getglobal("MovableHolyPower_frame_f"..i):Hide()
		end
	end
end	


function MovableHolyPower_resetData()
	
	MovableHolyPower_data={}
	MovableHolyPower_data.showOffCombat=nil
	MovableHolyPower_data.showWhenMounted=nil
	MovableHolyPower_data.showInVehicle=nil
	MovableHolyPower_data.scale=1
	MovableHolyPower_data.alpha=1
	MovableHolyPower_data.x=0
	MovableHolyPower_data.y=120
	MovableHolyPower_data.t0={}
	MovableHolyPower_data.t0.alpha=0.8
	MovableHolyPower_data.t0.scale=0.8
	MovableHolyPower_data.t1={}
	MovableHolyPower_data.t1.alpha=0.8
	MovableHolyPower_data.t1.scale=0.8	
	MovableHolyPower_data.t2={}
	MovableHolyPower_data.t2.alpha=0.8
	MovableHolyPower_data.t2.scale=0.9		
	MovableHolyPower_data.t3={}
	MovableHolyPower_data.t3.alpha=0.9
	MovableHolyPower_data.t3.scale=1
	
end


function MovableHolyPower_createFrames()


	-- Set up main frame
	MovableHolyPower_frame:SetPoint("CENTER",MovableHolyPower_data.x,MovableHolyPower_data.y)
	MovableHolyPower_frame:SetScale(MovableHolyPower_data.scale)
	MovableHolyPower_frame:SetAlpha(MovableHolyPower_data.alpha)
	MovableHolyPower_frame:Hide()
	
	--create subframes
	MovableHolyPower_frame_f0 = CreateFrame("Frame", nil, MovableHolyPower_frame)
	MovableHolyPower_frame_f0:SetPoint("CENTER")
	MovableHolyPower_frame_f0:SetWidth(128)
	MovableHolyPower_frame_f0:SetHeight(128)
	MovableHolyPower_frame_f0:SetScale(MovableHolyPower_data.t0.scale)
	MovableHolyPower_frame_f0:SetAlpha(MovableHolyPower_data.t0.alpha)
	
	
	MovableHolyPower_frame_f1 = CreateFrame("Frame", nil, MovableHolyPower_frame)
	MovableHolyPower_frame_f1:SetPoint("CENTER")
	MovableHolyPower_frame_f1:SetWidth(128)
	MovableHolyPower_frame_f1:SetHeight(128)
	MovableHolyPower_frame_f1:SetScale(MovableHolyPower_data.t1.scale)
	MovableHolyPower_frame_f1:SetAlpha(MovableHolyPower_data.t1.alpha)
	
	
	MovableHolyPower_frame_f2 = CreateFrame("Frame", nil, MovableHolyPower_frame)
	MovableHolyPower_frame_f2:SetPoint("CENTER")
	MovableHolyPower_frame_f2:SetWidth(128)
	MovableHolyPower_frame_f2:SetHeight(128)
	MovableHolyPower_frame_f2:SetScale(MovableHolyPower_data.t2.scale)
	MovableHolyPower_frame_f2:SetAlpha(MovableHolyPower_data.t2.alpha)
	

	MovableHolyPower_frame_f3 = CreateFrame("Frame", nil, MovableHolyPower_frame)
	MovableHolyPower_frame_f3:SetPoint("CENTER")
	MovableHolyPower_frame_f3:SetWidth(128)
	MovableHolyPower_frame_f3:SetHeight(128)
	MovableHolyPower_frame_f3:SetScale(MovableHolyPower_data.t3.scale)
	MovableHolyPower_frame_f3:SetAlpha(MovableHolyPower_data.t3.alpha)
	
	
	--texturize subframes
	MovableHolyPower_texture0 = MovableHolyPower_frame_f0:CreateTexture()
	MovableHolyPower_texture0:SetAllPoints(MovableHolyPower_frame_f0)
	MovableHolyPower_texture0:SetTexture("Interface\\Addons\\MovableHolyPower\\gfx\\0.tga")
	MovableHolyPower_frame_f0.texture=MovableHolyPower_texture0

        MovableHolyPower_texture1 = MovableHolyPower_frame_f1:CreateTexture()
	MovableHolyPower_texture1:SetAllPoints(MovableHolyPower_frame_f1)
	MovableHolyPower_texture1:SetTexture("Interface\\Addons\\MovableHolyPower\\gfx\\1.tga")
	MovableHolyPower_frame_f1.texture=MovableHolyPower_texture1
	
	MovableHolyPower_texture2 = MovableHolyPower_frame_f2:CreateTexture()
	MovableHolyPower_texture2:SetAllPoints(MovableHolyPower_frame_f2)
	MovableHolyPower_texture2:SetTexture("Interface\\Addons\\MovableHolyPower\\gfx\\2.tga")
	MovableHolyPower_frame_f2.texture=MovableHolyPower_texture2
		
	MovableHolyPower_texture3 = MovableHolyPower_frame_f3:CreateTexture()
	MovableHolyPower_texture3:SetAllPoints(MovableHolyPower_frame_f3)
	MovableHolyPower_texture3:SetTexture("Interface\\Addons\\MovableHolyPower\\gfx\\3.tga")
	MovableHolyPower_frame_f3.texture=MovableHolyPower_texture3
	

end


function MovableHolyPower_InitConfigPage()

	
	MovableHolyPower_optionsScaleSlider:SetValue(MovableHolyPower_data.scale)
	MovableHolyPower_optionsAlphaSlider:SetValue(MovableHolyPower_data.alpha)
	MovableHolyPower_optionsXSlider:SetValue(MovableHolyPower_data.x)
	MovableHolyPower_optionsYSlider:SetValue(MovableHolyPower_data.y)
	
  	MovableHolyPower_optionsScaleSliderText:SetText(MovableHolyPower_optionsScaleSlider:GetValue())
	MovableHolyPower_optionsAlphaSliderText:SetText(MovableHolyPower_optionsAlphaSlider:GetValue())
	MovableHolyPower_optionsXSliderText:SetText(MovableHolyPower_optionsXSlider:GetValue())
	MovableHolyPower_optionsYSliderText:SetText(MovableHolyPower_optionsYSlider:GetValue())
	
	MovableHolyPower_options0ASlider:SetValue(MovableHolyPower_data.t0.alpha)
	MovableHolyPower_options0SSlider:SetValue(MovableHolyPower_data.t0.scale)
	
	MovableHolyPower_options1ASlider:SetValue(MovableHolyPower_data.t1.alpha)
	MovableHolyPower_options1SSlider:SetValue(MovableHolyPower_data.t1.scale)
	
	MovableHolyPower_options2ASlider:SetValue(MovableHolyPower_data.t2.alpha)
	MovableHolyPower_options2SSlider:SetValue(MovableHolyPower_data.t2.scale)
	
	MovableHolyPower_options3ASlider:SetValue(MovableHolyPower_data.t3.alpha)
	MovableHolyPower_options3SSlider:SetValue(MovableHolyPower_data.t3.scale)
	
	
	MovableHolyPower_optionsImage0texture:SetScale(MovableHolyPower_data.t0.scale)
	MovableHolyPower_optionsImage0texture:SetAlpha(MovableHolyPower_data.t0.alpha)
	
	MovableHolyPower_optionsImage1texture:SetScale(MovableHolyPower_data.t1.scale)
	MovableHolyPower_optionsImage1texture:SetAlpha(MovableHolyPower_data.t1.alpha)
	
	MovableHolyPower_optionsImage2texture:SetScale(MovableHolyPower_data.t2.scale)
	MovableHolyPower_optionsImage2texture:SetAlpha(MovableHolyPower_data.t2.alpha)
	
	MovableHolyPower_optionsImage3texture:SetScale(MovableHolyPower_data.t3.scale)
	MovableHolyPower_optionsImage3texture:SetAlpha(MovableHolyPower_data.t3.alpha)
	
	
	for i=0,3 do	 
		getglobal("MovableHolyPower_options"..i.."ASliderLow"):SetText("")
		getglobal("MovableHolyPower_options"..i.."ASliderHigh"):SetText("")
		getglobal("MovableHolyPower_options"..i.."SSliderLow"):SetText("")
		getglobal("MovableHolyPower_options"..i.."SSliderHigh"):SetText("")
		
		getglobal("MovableHolyPower_options"..i.."ASliderText"):SetText("alpha")
		getglobal("MovableHolyPower_options"..i.."SSliderText"):SetText("size")
	end
		

	MovableHolyPower_optionsShowOffCombat:SetChecked(MovableHolyPower_data.showOffCombat)
	MovableHolyPower_optionsShowWhenMounted:SetChecked(MovableHolyPower_data.showWhenMounted)
	MovableHolyPower_optionsShowInVehicle:SetChecked(MovableHolyPower_data.showInVehicle)
	
	
end

function MovableHolyPower_SliderChanged(this)

	if MovableHolyPower_data then 
	
		local ctrl = this:GetName()
		
		if ctrl == "MovableHolyPower_options3ASlider"   then
			MovableHolyPower_optionsImage3texture:SetAlpha(MovableHolyPower_options3ASlider:GetValue())
		end	
		if ctrl == "MovableHolyPower_options3SSlider"   then
			MovableHolyPower_optionsImage3texture:SetScale(MovableHolyPower_options3SSlider:GetValue())
		end
		
		if ctrl == "MovableHolyPower_options2ASlider"   then
			MovableHolyPower_optionsImage2texture:SetAlpha(MovableHolyPower_options2ASlider:GetValue())
		end
		if ctrl == "MovableHolyPower_options2SSlider"   then
			MovableHolyPower_optionsImage2texture:SetScale(MovableHolyPower_options2SSlider:GetValue())
		end
		
		if ctrl == "MovableHolyPower_options1ASlider"   then
			MovableHolyPower_optionsImage1texture:SetAlpha(MovableHolyPower_options1ASlider:GetValue())
		end
		if ctrl == "MovableHolyPower_options1SSlider"   then
			MovableHolyPower_optionsImage1texture:SetScale(MovableHolyPower_options1SSlider:GetValue())
		end
	
		if ctrl == "MovableHolyPower_options0ASlider"   then
			MovableHolyPower_optionsImage0texture:SetAlpha(MovableHolyPower_options0ASlider:GetValue())
		end	
		if ctrl == "MovableHolyPower_options0SSlider"   then
			MovableHolyPower_optionsImage0texture:SetScale(MovableHolyPower_options0SSlider:GetValue())
		end
		
			
		if ctrl ==  "MovableHolyPower_optionsScaleSlider"   then
			MovableHolyPower_optionsScaleSliderText:SetText(this:GetValue())
			MovableHolyPower_frame:SetScale(this:GetValue())
		end	
		if ctrl ==  "MovableHolyPower_optionsAlphaSlider"   then
			MovableHolyPower_optionsAlphaSliderText:SetText(this:GetValue())
			MovableHolyPower_frame:SetAlpha(this:GetValue())
		end	
		if ctrl ==  "MovableHolyPower_optionsXSlider"   then
			MovableHolyPower_optionsXSliderText:SetText(this:GetValue())
			MovableHolyPower_frame:ClearAllPoints()
			MovableHolyPower_frame:SetPoint("CENTER",MovableHolyPower_optionsXSlider:GetValue(),MovableHolyPower_optionsYSlider:GetValue())
			
		end	
		if ctrl ==  "MovableHolyPower_optionsYSlider"   then 
			MovableHolyPower_optionsYSliderText:SetText(this:GetValue())
			MovableHolyPower_frame:ClearAllPoints()
			MovableHolyPower_frame:SetPoint("CENTER",MovableHolyPower_optionsXSlider:GetValue(),MovableHolyPower_optionsYSlider:GetValue())
		end	
		
	end	
end

function MovableHolyPower_optionsSHOW()

	MovableHolyPower_frame:Show()
	MovableHolyPower_InitConfigPage()
        MovableHolyPower_frame_f3:Show()
end	


function MovableHolyPower_PanelCancel()

	--restore main frame
	--no need to restore small ones, InitConfigPage() will do next optionsSHOW()
	MovableHolyPower_frame:SetScale(MovableHolyPower_data.scale )
        MovableHolyPower_frame:SetAlpha(MovableHolyPower_data.alpha )
        MovableHolyPower_frame:ClearAllPoints()
	MovableHolyPower_frame:SetPoint("CENTER",MovableHolyPower_data.x,MovableHolyPower_data.y)

 	MovableHolyPower_frame:Hide()
 	
end

function MovableHolyPower_PanelOk()

	MovableHolyPower_frame:Hide()
	
	_, _, _, MovableHolyPower_data.x, MovableHolyPower_data.y = MovableHolyPower_frame:GetPoint(1)
	MovableHolyPower_data.scale = MovableHolyPower_frame:GetScale()
        MovableHolyPower_data.alpha = MovableHolyPower_frame:GetAlpha()
        
        MovableHolyPower_data.t0.scale = MovableHolyPower_optionsImage0texture:GetScale()
	MovableHolyPower_data.t0.alpha = MovableHolyPower_optionsImage0texture:GetAlpha()
	MovableHolyPower_data.t1.scale = MovableHolyPower_optionsImage1texture:GetScale()
	MovableHolyPower_data.t1.alpha = MovableHolyPower_optionsImage1texture:GetAlpha()
	MovableHolyPower_data.t2.scale = MovableHolyPower_optionsImage2texture:GetScale()
	MovableHolyPower_data.t2.alpha = MovableHolyPower_optionsImage2texture:GetAlpha()
	MovableHolyPower_data.t3.scale = MovableHolyPower_optionsImage3texture:GetScale()
	MovableHolyPower_data.t3.alpha = MovableHolyPower_optionsImage3texture:GetAlpha()
        
	MovableHolyPower_frame_f0:SetScale(MovableHolyPower_data.t0.scale)
	MovableHolyPower_frame_f0:SetAlpha(MovableHolyPower_data.t0.alpha)
	MovableHolyPower_frame_f1:SetScale(MovableHolyPower_data.t1.scale)
	MovableHolyPower_frame_f1:SetAlpha(MovableHolyPower_data.t1.alpha)
	MovableHolyPower_frame_f2:SetScale(MovableHolyPower_data.t2.scale)
	MovableHolyPower_frame_f2:SetAlpha(MovableHolyPower_data.t2.alpha)
	MovableHolyPower_frame_f3:SetScale(MovableHolyPower_data.t3.scale)
	MovableHolyPower_frame_f3:SetAlpha(MovableHolyPower_data.t3.alpha)
	
	MovableHolyPower_Refresh()
	
end


function MovableHolyPower_ShowOffCombatClick(this)

	MovableHolyPower_data.showOffCombat = MovableHolyPower_optionsShowOffCombat:GetChecked()
	MovableHolyPower_Refresh()	

end


function MovableHolyPower_ShowWhenMountedClick(this)

	MovableHolyPower_data.showWhenMounted = MovableHolyPower_optionsShowWhenMounted:GetChecked()
	MovableHolyPower_Refresh()	

end

function MovableHolyPower_ShowInVehicleClick(this)

	MovableHolyPower_data.showInVehicle = MovableHolyPower_optionsShowInVehicle:GetChecked()
	MovableHolyPower_Refresh()	

end